﻿using UnityEngine;
using System.Collections.Generic;
using System.Linq;

/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea 
Email:819661664@qq.com
Patreon:https://www.patreon.com/PluginIdea

Licensed under CC BY-SA after EarlyAccess ended. (see https://creativecommons.org/licenses/by-sa/4.0/)

///////////////////////////////////////////////////////////////////////////////////////////////// */

namespace PluginIdea
{
    public class ClothModule : EasyMorphyModuleBase
    {

        private DAZCharacterSelector dazcharacterSelector;
        private List<DAZClothingItem> activedClothingItems;
        private List<DAZHairGroup> activeHairItems;

        public ClothModule(EasyMorphy ower)
        {
            this.ower = ower;
        }

        public override void Init()
        {
            JSONStorable storableByID = ower.containingAtom.GetStorableByID("geometry");
            if (storableByID != null)
            {
                dazcharacterSelector = storableByID as DAZCharacterSelector;
                activedClothingItems = dazcharacterSelector.clothingItems.Where(x => x.active == true).ToList();
                activeHairItems = dazcharacterSelector.hairItems.Where(x => x.active == true).ToList();
            }
        }

        public void ShowHideAllCloth(bool isActive)
        {
            if (activedClothingItems.Count > 0)
            {
                activedClothingItems.ForEach(cloth => {
                    dazcharacterSelector.SetActiveClothingItem(cloth, isActive);
                });
            }
        }

        public void ShowHideAllHair(bool isActive)
        {
            if (activeHairItems.Count > 0)
            {
                activeHairItems.ForEach(hair => {
                    dazcharacterSelector.SetActiveHairItem(hair, isActive);
                });
            }
        }

        public override void UnInit()
        {

        }
    }
}


