﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;

namespace PluginIdea
{
    public class Draggable : MonoBehaviour, IDragHandler, IPointerDownHandler
    {

        [SerializeField] private RectTransform dragTarget;
        [SerializeField] private Canvas canvas;

        private void Awake()
        {
            if (dragTarget == null) dragTarget = transform.GetComponent<RectTransform>();
            if (canvas == null) canvas = transform.parent.GetComponent<Canvas>();
        }

        public void OnDrag(PointerEventData eventData)
        {
            dragTarget.anchoredPosition += eventData.delta / canvas.scaleFactor;
        }

        public void OnPointerDown(PointerEventData eventData)
        {
            dragTarget.SetAsLastSibling();
        }
    }
}
