﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using System.Linq;
using System;
using UnityEngine.EventSystems;

namespace PluginIdea
{
    public struct OptionData
    {
        public string morphName;
        public string region;
    }

    public class PDropDown : MonoBehaviour
    {

        private ScrollRect scrollRect;
        private GameObject itemTemplate;
        private Text valueText;
        private int value;

        private List<OptionData> options;
        private List<GameObject> selectItems;
        public Action<int, GameObject> onSelectValueChanged;

        public int Value
        {
            get { return this.value; }
        }

        public bool DropListActive
        {
            set {
                scrollRect.gameObject.SetActive(value);
            }
        }

        public List<OptionData> Options
        {
            set { this.options = value; }
            get { return this.options; }
        }

        void Start()
        {
            scrollRect = transform.Find("Template").GetComponent<ScrollRect>();
            itemTemplate = transform.Find("Template/Viewport/Content/Item").gameObject;
            valueText = transform.Find("Label").GetComponent<Text>();

            selectItems = new List<GameObject>();

            InitEvent();
        }

        void InitEvent()
        {
            PEventListener.Get(gameObject).onClick = (go) => {
                scrollRect.gameObject.SetActive(!scrollRect.gameObject.activeInHierarchy);
                ShowItems(scrollRect.gameObject.activeInHierarchy);

            };
        }

        public void ShowItems(bool isShow)
        {
            if (!isShow) return;

            if (selectItems.Count > 0)
            {
                for (int i = 0; i < selectItems.Count; i++)
                {
                    Destroy(selectItems[i].gameObject);
                }
                selectItems.Clear();
            }

            if (options.Count > 0)
            {
                for (int i = 0; i < options.Count; i++)
                {
                    GameObject item = Instantiate<GameObject>(itemTemplate, itemTemplate.transform.parent);
                    item.transform.Find("Item Label").GetComponent<Text>().text = options[i].morphName;
                    item.transform.Find("ItemRegionLabel").GetComponent<Text>().text = options[i].region;
                    item.name = i.ToString();
                    item.SetActive(true);
                    selectItems.Add(item);
                    PEventListener.Get(item).onClick = (gameObject) => {
                        scrollRect.gameObject.SetActive(false);
                        int index = int.Parse(gameObject.name);
                        this.value = index;
                        valueText.text = options[index].morphName;
                        if (onSelectValueChanged != null)
                        {
                            onSelectValueChanged(index, gameObject);
                        }
                    };
                }
            }
        }

        private void OnDestroy()
        {

        }
    }

}

